// Z҃NCAg̃TvvO\[XR[hJava 
// ̃vOӐ}Ƃ͌܂̂ŁAȐӔCŗpĂB
// Java SE 6 Update 21œmF܂B
// vLVoRł̒ʐM̏ꍇAsɃIvV"-Djava.net.useSystemProxies=true"Ȃǂ̕Kv܂B
import java.io.*;
import java.util.*;
import javax.xml.*;
import javax.xml.parsers.*;
import javax.xml.xpath.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/** 
 * Tv̋ZNCAgNXłB
 * T[o[ɂĎ(}bvȂ)JꂽɎsĂBZ̍ŒɋNĂ肠܂B
 * ŏɌĂ΂main()\bhSampleClient쐬ɁAReXgID`[IDA`[g[Nw肵ĂB
 * ZNCAg̊Jɂ̃NXLp΁Ainstruct()\bhmFĂB
 * ̃\bh߂̌ɂ镔łB
 * instruct()\bhA܂̓I[o[Ch邱ƂɂĖߌ̃WbNg݊邱Ƃł܂B
 */
public class SampleClient{
	protected String serverHost;
	protected int contestId;
	protected int teamId;
	protected String teamToken;
	
	/** (Q[JnɈx擾)i[܂B */
	protected GameInfo gameInfo;
	/** ̏(ZbVƂɖߑM̌ʂƂĎ擾)i[܂B */
	protected BattleState battleState;
	/** gameInfoteamInfozAbattleStateteamStatez̎̃`[ɑΉCfbNXłB */
	protected int myTeamIndex;
	
	/**
	 * SampleClient쐬܂B 
	 * serverHostɃT[o[̃zXgAcontestIdɃReXgIDAteamIdɃ`[IDAteamTokenɃ`[g[Nw肵ĂB
	 */
	public SampleClient(String serverHost, int contestId, int teamId, String teamToken){
		this.serverHost = serverHost;
		this.contestId = contestId;
		this.teamId = teamId;
		this.teamToken = teamToken;
		gameInfo = new GameInfo();
		battleState = new BattleState();
	}
	
	/**
	 * _E[hāAgameInfoɊi[܂B
	 * AgameInfoteamInfoid̏Ƀ\[g܂B
	 * myTeamIndexɂteamInfo̔z̎̃`[ɂCfbNXݒ肳܂B
	 * ܂AbattleStateɂ`[ID⏉ʒui[܂B
	 */
	protected boolean downloadGameInfo(){
		try{
			System.out.println("Downloading... ");
			
			Document doc = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(
				"http://" + serverHost + "/system/map/contest_id=" + contestId);
			XPath xpath = XPathFactory.newInstance().newXPath();
			
			String error = xpath.evaluate("/data/error", doc);
			if(!error.equals("")){
				System.out.println(error);
				return false;
			}
			
			gameInfo.title = xpath.evaluate("/data/title", doc);
			gameInfo.totalSession = Integer.parseInt(xpath.evaluate("/data/total_session", doc));
			String[] s;
			s = xpath.evaluate("/data/map", doc).split(",");
			for(int i = 0; i < s.length; i++) gameInfo.map[i] = Integer.parseInt(s[i]);
			NodeList nodes = (NodeList)xpath.evaluate("/data/site", doc, XPathConstants.NODESET);
			for(int i = 0; i < nodes.getLength(); i++){
				gameInfo.teamInfo[i] = new TeamInfo();
				gameInfo.teamInfo[i].domain = xpath.evaluate("domain", nodes.item(i));
				gameInfo.teamInfo[i].id = Integer.parseInt(xpath.evaluate("id", nodes.item(i)));
				gameInfo.teamInfo[i].name = xpath.evaluate("name", nodes.item(i));
				s = xpath.evaluate("start_position", nodes.item(i)).split(",");
				for(int j = 0; j < s.length; j++){
					gameInfo.teamInfo[i].startPosition[j] = Integer.parseInt(s[j]);
				}
			}
			Arrays.sort(gameInfo.teamInfo);
			for(int i = 0; i < gameInfo.teamInfo.length; i++){
				if(gameInfo.teamInfo[i].id == teamId) myTeamIndex = i;
			}
			
			for(int i = 0; i < battleState.teamState.length; i++){
				battleState.teamState[i] = new TeamState();
				battleState.teamState[i].teamId = gameInfo.teamInfo[i].id;
				for(int j = 0; j < 3; j++){
					battleState.teamState[i].machineState[j] = new MachineState();
					battleState.teamState[i].machineState[j].number = j + 1;
					battleState.teamState[i].machineState[j].position = gameInfo.teamInfo[i].startPosition[j];
				}
			}
			return true;
		}catch(Exception e){
			e.printStackTrace();
			return false;
		}
	}
	
	/**
	 * {bg3̖̕߂𑗐MāǍʂbattleStateɊi[܂B
	 * AbattleStateteamInfoteam_id̏Ƀ\[g܂B
	 * ܂AteamInfomachineInfo͂ꂼnumbeȑɃ\[g܂B
	 */
	protected void sendInstructions(String[] instructions){
		try{
			System.out.println("Sending... (" + instructions[0] + "," + instructions[1] + "," + instructions[2] + ")");
			
			Document doc = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(
				"http://" + serverHost + "/system/command/machine_1=" + instructions[0] + 
				"&machine_2=" + instructions[1] + "&machine_3=" + instructions[2] + 
				"&token=" + teamToken + "&contest_id=" + contestId);
			XPath xpath = XPathFactory.newInstance().newXPath();
			
			String error = xpath.evaluate("/data/error", doc);
			if(!error.equals("")){
				System.out.println(error);
				return;
			}
			
			battleState = new BattleState();
			battleState.session = Integer.parseInt(xpath.evaluate("/data/session", doc));
			String[] s;
			s = xpath.evaluate("/data/map/owner", doc).split(",");
			for(int i = 0; i < s.length; i++) battleState.owner[i] = Integer.parseInt(s[i]);
			s = xpath.evaluate("/data/map/provision", doc).split(",");
			for(int i = 0; i < s.length; i++) battleState.provision[i] = Integer.parseInt(s[i]);
			NodeList nodes = (NodeList)xpath.evaluate("/data/team", doc, XPathConstants.NODESET);
			for(int i = 0; i < nodes.getLength(); i++){
				battleState.teamState[i] = new TeamState();
				battleState.teamState[i].teamId = Integer.parseInt(xpath.evaluate("team_id", nodes.item(i)));
				NodeList mnodes = (NodeList)xpath.evaluate("machine", nodes.item(i), XPathConstants.NODESET);
				for(int j = 0; j < mnodes.getLength(); j++){
					battleState.teamState[i].machineState[j] = new MachineState();
					battleState.teamState[i].machineState[j].number = Integer.parseInt(xpath.evaluate("number", mnodes.item(j)));
					battleState.teamState[i].machineState[j].carryover = Integer.parseInt(xpath.evaluate("carryover", mnodes.item(j)));
					battleState.teamState[i].machineState[j].position = Integer.parseInt(xpath.evaluate("position", mnodes.item(j)));
					battleState.teamState[i].machineState[j].ryoma = Integer.parseInt(xpath.evaluate("ryoma", mnodes.item(j)));
				}
				Arrays.sort(battleState.teamState[i].machineState);
			}
			Arrays.sort(battleState.teamState);
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	/**
	 * {bg3̖̕߂肵đM܂BZbVƂɌĂяo܂B
	 * ̃\bhA܂̓I[o[Ch邱ƂɂĖߌ̃WbNg݊邱Ƃł܂B
	 * gameInfobattleStateQƂ̖߂lAsendInstructions()ĂяoƂɂȂ܂B
	 */
	protected void instruct(){
		// ƂāA{bg1"712173"A{bg2"237422"A{bg3"837333"𑗐MĂ܂B
		String[] instructions = new String[3];
		instructions[0] = "712173";
		instructions[1] = "237422";
		instructions[2] = "837333";
		
		// ႦΎ̃vO}ƁA
		// {bg̍ɓG`[ɂĔzꂽZɂ́AɈړ铮s悤ɂȂ܂B
		// for(int i = 0; i < 3; i++){
		// 	int pos = battleState.teamState[myTeamIndex].machineState[i].position; // ݈ʒu
		// 	int newPos = pos - 42; // ݈ʒu̍̈ʒu
		// 	if(newPos >= 0 && battleState.provision[newPos] > 0 && battleState.owner[newPos] != teamId){
		// 		instructions[i] = "6666666";
		// 	}
		// }
		
		// ߂𑗐M 
		sendInstructions(instructions);
	}
	
	/**
	 * NCAgs܂B
	 * ܂n߂ɁAdownloadGameInfo()ĂяoƂŁA_E[h܂B
	 * ̌AJԂinstruct()ĂяoƂɂAeZbV̖߂肵đM܂B
	 * ͖ߑM̃^C~OZbVXV(3bԊu)ɓ܂B
	 */
	public void run(){
		try{
			// _E[h 
			if(!downloadGameInfo()) return;
			// _E[hƃZbV\ 
			System.out.println("Game Title: " + gameInfo.title);
			System.out.println("Total Session: " + gameInfo.totalSession);
			
			while(true){
				// ݂(̏I)ZbVԍ\ 
				System.out.println("Processed Session: " + battleState.session);
				if(battleState.session >= gameInfo.totalSession) break;
				// ߂肵đM 
				instruct();
				// 1b҂ 
				Thread.sleep(1000);
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	/**
	 * vOsAŏɌĂ΂郁\bhłB 
	 * SampleClient̃CX^X쐬Arun()ĂяoƂɂNCAgs܂B
	 */
	public static void main(String[] args){
		// SampleClient쐬̈ɃT[o[̃zXgAReXgIDA`[IDA`[g[Nw肵ĂB
		new SampleClient("procon-online.net", 1, 1, "abcde").run();
	}
	
	
	
	
	// --------------------------------------------------------------------------------------------------
	// ȍ~́Af[^i[p̃NX̒`łBɁA
	// E(Q[JnɈx擾}bvȂǂɊւ)ƁA
	// Ȅ(ZbVƂɖߑM̌ʂƂĎ擾)
	// ܂B
	// --------------------------------------------------------------------------------------------------
	
	/**
	 * i[NXłB 
	 */
	public class GameInfo{
		public String title;
		public int totalSession;
		public int[] map = new int[41 * 41];
		public TeamInfo[] teamInfo = new TeamInfo[6];
	}

	/**
	 * (GameInfo)̒́A`[Ƃ̏i[NXłB 
	 */
	public class TeamInfo implements Comparable<TeamInfo>{
		public String domain;
		public int id;
		public String name;
		public int[] startPosition = new int[3];
		
		public int compareTo(TeamInfo a){
			return id - a.id;
		}
	}

	/**
	 * ̏󋵂i[NXłB 
	 */
	public class BattleState{
		public int session;
		public int[] owner = new int[41 * 41];
		public int[] provision = new int[41 * 41];
		public TeamState[] teamState = new TeamState[6];
	}

	/**
	 * ̏(BattleState)̒ŁA`[Ƃ̏󋵂i[NXłB 
	 */
	public class TeamState implements Comparable<TeamState>{
		public int teamId;
		public MachineState[] machineState = new MachineState[3];
		
		public int compareTo(TeamState a){
			return teamId - a.teamId;
		}
	}

	/**
	 * ̏(BattleState)̒́A`[Ƃ̏(TeamState)̒ŁA{bgƂ̏󋵂i[NXłB 
	 */
	public class MachineState implements Comparable<MachineState>{
		public int carryover;
		public int number;
		public int position;
		public int ryoma;
		
		public int compareTo(MachineState a){
			return number - a.number;
		}
	}
}
